package com.bcb.carmaster.ui

import android.os.Bundle
import android.view.View
import android.widget.ImageView
import android.widget.TextView
import com.bcb.carmaster.R
import com.bcb.carmaster.clicker.MainCfgClicker
import com.bcb.carmaster.common.ShowDialog
import com.bcb.carmaster.utils.ToastUtils
import com.bcb.cfg.AppConstants
import com.bumptech.glide.Glide
import com.loopj.http.bcb.CMJsonCallback
import com.loopj.http.bcb.CMRequestType
import com.loopj.http.entity.BankConfigBean
import com.loopj.http.entity.BankProgressBean
import com.loopj.http.entity.BaseEntity
import org.apache.http.Header
import java.util.*

class BankActivityActivity: BaseActivity() {
    private var status = 0
    private lateinit var iv_btn:ImageView
    private lateinit var tv_btn:TextView
    private  var result:BankConfigBean.BankConfigResult? = null
    private var isFirst = true
    override fun onCreate(arg0: Bundle?) {
        super.onCreate(arg0)
        setContentView(R.layout.activity_bank_activity)
        initView()
        initData()
    }

    private fun initView() {
        iv_btn = findViewById<ImageView>(R.id.iv_btn)
        tv_btn = findViewById<TextView>(R.id.tv_btn)
    }

    private fun initData() {
        getConfig()
        getProgress()
//        submit()
    }

    override fun onResume() {
        super.onResume()
        if(!isFirst)
        {
            getConfig()
            getProgress()
        }
    }
    private fun submitData( name:String, mobile:String, address:String) {
//        /api6.1/ccb/submit-address
        var params =  HashMap<String,String>()
        params.put("name",name)
        params.put("mobile",mobile)
        params.put("address",address)
        sender.postWithTokenOnUI(this,CMRequestType.SUBMIT_ADDRESS,params,AppConstants.SOURCE_SECRET,object :CMJsonCallback{
            override fun onSuccess(tag: String?, obj: Any?, headers: Array<out Header>?) {
                var bean = obj as BaseEntity
                if(bean.code == 0)
                {
                    ToastUtils.toast(this@BankActivityActivity,"提交成功")
                }
                getProgress()
            }

            override fun onFail(tag: String?, code: Int, message: String?, headers: Array<out Header>?) {
            }

        })
    }

    private fun getConfig() {
        var params =  HashMap<String,String>()
        sender.getWithTokenOnUI(this,CMRequestType.CCB_CONFIG,params,AppConstants.SOURCE_SECRET,object :CMJsonCallback{
            override fun onSuccess(tag: String?, obj: Any?, headers: Array<out Header>?) {
               var bean = obj as BankConfigBean
                if (bean!!.code == 0)
                {
                    result = bean!!.result
                }
            }

            override fun onFail(tag: String?, code: Int, message: String?, headers: Array<out Header>?) {
            }

        })
    }
//进度: 0-未参与活动 1-已成功注册未填写收获信息(未领取)  2-已填写收获信息（已领取）
    private fun getProgress() {
        var params =  HashMap<String,String>()
        sender.getWithTokenOnUI(this,CMRequestType.CCB_PROCESS,params,AppConstants.SOURCE_SECRET,object :CMJsonCallback{
            override fun onSuccess(tag: String?, obj: Any?, headers: Array<out Header>?) {
                var progress  = obj as BankProgressBean
                if (progress.code == 0)
                {
                    var result = progress.result
                    isFirst = false
                    if(result!=null)
                    {
                        status =  result.status
//                        status = 1
                        initBtnStatus(status)

                    }
                }

            }

            override fun onFail(tag: String?, code: Int, message: String?, headers: Array<out Header>?) {
            }

        })
    }

    private fun initBtnStatus(status: Int) {
        when(status){
            0->{
                Glide.with(this).load(R.drawable.icon_bank_btn_red).into(iv_btn)
//                iv_btn.setBackgroundResource(R.drawable.icon_bank_btn_red)
                tv_btn.setText("立即参与")
                iv_btn.isClickable  =  true
            }
            1->{

                Glide.with(this).load(R.drawable.icon_bank_btn_yellow).into(iv_btn)
//                iv_btn.setBackgroundResource(R.drawable.icon_bank_btn_yellow)
                tv_btn.setText("立即领取")
                iv_btn.isClickable  =  true
                showAddressDialog()
            }
            2->{
                Glide.with(this).load(R.drawable.icon_bank_btn_gray).into(iv_btn)
//                iv_btn.setBackgroundResource(R.drawable.icon_bank_btn_gray)
                tv_btn.setText("已参与")
                iv_btn.isClickable  =  false
            }
            3->{
                Glide.with(this).load(R.drawable.icon_bank_btn_gray).into(iv_btn)
//                iv_btn.setBackgroundResource(R.drawable.icon_bank_btn_gray)
                tv_btn.setText("已结束")
                iv_btn.isClickable  =  false
            }
        }

    }

    fun toNext(view: View) {
        when(status){
            0->{
                MainCfgClicker("qcdsuser://CCB/DrctBnk",this,result).setLoginFlag(1).onClick(null)
            }
            1->{
                showAddressDialog()
            }
        }

    }
    fun showAddressDialog(){
        ShowDialog.showActivityAddressDialog(this,object :ShowDialog.OnAddSubmitListener{
            override fun submit(name: String, phone: String, address: String) {
                submitData(name,phone,address)
            }

        })
    }
}